/***************************************************************************
 *   Copyright (C) 2007 by Todor Gyumyushev   *
 *   yodor@developer.bg   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TTIP_H
#define TTIP_H

#include <qwidget.h>
#include <qevent.h>
#include "speedframe.h"
#include "knetdockif.h"
#include "dockif.h"

/**
	@author Todor Gyumyushev <yodor@developer.bg>
*/

class DockIf;

class TTip : public QWidget
{
Q_OBJECT
public:
    TTip(DockIf *parent = 0, const char *name = 0, WFlags f= WX11BypassWM);
    ~TTip();
	void setTipEnabled(bool mode);
	bool isTipEnabled();

public slots:
	void update(const KNetDockIf *nif);
	
protected:
	virtual void paintEvent(QPaintEvent *e);
	virtual void resizeEvent(QResizeEvent *e);

private:
	SpeedFrame *s;
	QLabel *l;
	QLabel *wifi_label;
	bool tipEnabled;
	DockIf *m_dock;
};

#endif
